import IBIZUNIProductService from '@/service/ibizuniproduct/ibizuniproduct-service';
import { Verify } from '@/utils/verify/verify';


/**
 * 通过商品ID获取单价及单位
 * 基于 APP/src/service/%DE_PKGPATH%/%APP_DELOGIC%-logic-base.ts.ftl 生成
 * @export
 * @class GetUnitAndPriceLogicBase
 */
export default class GetUnitAndPriceLogicBase {

    /**
     * 名称
     * 
     * @memberof  GetUnitAndPriceLogicBase
     */
    private name:string ="GetUnitAndPrice";

    /**
     * 唯一标识
     * 
     * @memberof  GetUnitAndPriceLogicBase
     */
    private id:string = "ded186a4036f371f623ecdb8b799f94c";

    /**
     * 默认参数名称
     * 
     * @memberof  GetUnitAndPriceLogicBase
     */
    private defaultParamName:string = "Default";

    /**
     * 参数集合
     * 
     * @memberof  GetUnitAndPriceLogicBase
     */
    private paramsMap:Map<string,any> = new Map();

    /**
     * Creates an instance of  GetUnitAndPriceLogicBase.
     * 
     * @param {*} [opts={}]
     * @memberof  GetUnitAndPriceLogicBase
     */
    constructor(opts: any = {}) {
        this.initParams(opts);
    }

    /**
     * 初始化参数集合
     * 
     * @param {*} [opts={}]
     * @memberof  GetUnitAndPriceLogicBase
     */
    public initParams(opts:any){
        this.paramsMap.set('Product',{});
        this.paramsMap.set('Order',{});
        this.paramsMap.set('Default',opts);
    }


    /**
     * 计算0节点结果
     * 
     * @param params 传入参数
     */
    public compute0Cond(params:any):boolean{
        return true;
    }

    /**
     * 计算1节点结果
     * 
     * @param params 传入参数
     */
    public compute1Cond(params:any):boolean{
        return true;
    }

    /**
     * 计算2节点结果
     * 
     * @param params 传入参数
     */
    public compute2Cond(params:any):boolean{
        return true;
    }

    /**
     * 计算3节点结果
     * 
     * @param params 传入参数
     */
    public compute3Cond(params:any):boolean{
        return true;
    }

    /**
     * 计算4节点结果
     * 
     * @param params 传入参数
     */
    public compute4Cond(params:any):boolean{
        return true;
    }

    /**
     * 执行逻辑
     * 
     * @param context 应用上下文
     * @param params 传入参数
     */
    public onExecute(context:any,params:any,isloading:boolean){
        return this.executeBegin(context,params,isloading);
    }


    /**
    * 开始
    * 
    * @param params 传入参数
    */
    private async executeBegin(context:any,params:any,isloading:boolean){
        //开始节点
        if(this.compute0Cond(params)){
            return this.executePrepareparam1(context,params,isloading);   
        }
    }

    /**
    * 实体处理逻辑
    * 
    * @param context 应用上下文
    * @param params 传入参数
    */
    private async executeDELOGIC1(context:any,params:any,isloading:boolean){
        // DELOGIC暂未支持
        console.log("DELOGIC暂未支持");
        return this.paramsMap.get(this.defaultParamName).data;
    }

    /**
    * 直接SQL并循环调用
    * 
    * @param context 应用上下文
    * @param params 传入参数
    */
    private async executeRAWSQLANDLOOPCALL1(context:any,params:any,isloading:boolean){
        // RAWSQLANDLOOPCALL暂未支持
        console.log("RAWSQLANDLOOPCALL暂未支持");
        return this.paramsMap.get(this.defaultParamName).data;
    }

    /**
    * 外部接口调用
    * 
    * @param context 应用上下文
    * @param params 传入参数
    */
    private async executeSUBSYSSAMETHOD1(context:any,params:any,isloading:boolean){
        // SUBSYSSAMETHOD暂未支持
        console.log("SUBSYSSAMETHOD暂未支持");
        return this.paramsMap.get(this.defaultParamName).data;
    }

    /**
    * 获取产品价格异常
    * 
    * @param context 应用上下文
    * @param params 传入参数
    */
    private async executeThrowexception(context:any,params:any,isloading:boolean){
        // 异常捕获节点
        return this.paramsMap.get(this.defaultParamName).data;
    }

    /**
    * 调试逻辑参数
    * 
    * @param context 应用上下文
    * @param params 传入参数
    */
    private async executeDEBUGPARAM1(context:any,params:any,isloading:boolean){
        // DEBUGPARAM暂未支持
        console.log("DEBUGPARAM暂未支持");
        return this.paramsMap.get(this.defaultParamName).data;
    }

    /**
    * 实体数据查询
    * 
    * @param context 应用上下文
    * @param params 传入参数
    */
    private async executeDEDATAQUERY1(context:any,params:any,isloading:boolean){
        // DEDATAQUERY暂未支持
        console.log("DEDATAQUERY暂未支持");
        return this.paramsMap.get(this.defaultParamName).data;
    }

    /**
    * 取消流程
    * 
    * @param context 应用上下文
    * @param params 传入参数
    */
    private async executeCANCELWF1(context:any,params:any,isloading:boolean){
        // CANCELWF暂未支持
        console.log("CANCELWF暂未支持");
        return this.paramsMap.get(this.defaultParamName).data;
    }

    /**
    * 系统逻辑处理
    * 
    * @param context 应用上下文
    * @param params 传入参数
    */
    private async executeSYSLOGIC1(context:any,params:any,isloading:boolean){
        // SYSLOGIC暂未支持
        console.log("SYSLOGIC暂未支持");
        return this.paramsMap.get(this.defaultParamName).data;
    }

    /**
    * 获取商品ID
    * 
    * @param context 应用上下文
    * @param params 传入参数
    */
    private async executePrepareparam1(context:any,params:any,isloading:boolean){
        // 准备参数节点
    let tempDstParam0Context:any = this.paramsMap.get('Product').context?this.paramsMap.get('Product').context:{};
    let tempDstParam0Data:any = this.paramsMap.get('Product').data?this.paramsMap.get('Product').data:{};
    let tempSrcParam0Data:any = this.paramsMap.get('Default').data?this.paramsMap.get('Default').data:{};
    Object.assign(tempDstParam0Context,{ibizuniproduct:tempSrcParam0Data['ibizuniproductid']});
    Object.assign(tempDstParam0Data,{ibizuniproductid:tempSrcParam0Data['ibizuniproductid']});
    this.paramsMap.set('Product',{data:tempDstParam0Data,context:tempDstParam0Context});
        if(this.compute1Cond(params)){
            return this.executeDeaction1(context,params,isloading);   
        }
    }

    /**
    * 启动流程
    * 
    * @param context 应用上下文
    * @param params 传入参数
    */
    private async executeSTARTWF1(context:any,params:any,isloading:boolean){
        // 开始流程节点
        return this.paramsMap.get(this.defaultParamName).data;
    }

    /**
    * 填充单位和单价
    * 
    * @param context 应用上下文
    * @param params 传入参数
    */
    private async executePrepareparam2(context:any,params:any,isloading:boolean){
        // 准备参数节点
    let tempDstParam0Context:any = this.paramsMap.get('Default').context?this.paramsMap.get('Default').context:{};
    let tempDstParam0Data:any = this.paramsMap.get('Default').data?this.paramsMap.get('Default').data:{};
    let tempSrcParam0Data:any = this.paramsMap.get('Product').data?this.paramsMap.get('Product').data:{};
    Object.assign(tempDstParam0Data,{unit:tempSrcParam0Data['unit']});
    this.paramsMap.set('Default',{data:tempDstParam0Data,context:tempDstParam0Context});
    let tempDstParam1Context:any = this.paramsMap.get('Default').context?this.paramsMap.get('Default').context:{};
    let tempDstParam1Data:any = this.paramsMap.get('Default').data?this.paramsMap.get('Default').data:{};
    let tempSrcParam1Data:any = this.paramsMap.get('Product').data?this.paramsMap.get('Product').data:{};
    Object.assign(tempDstParam1Data,{unitprice:tempSrcParam1Data['unitprice']});
    this.paramsMap.set('Default',{data:tempDstParam1Data,context:tempDstParam1Context});
        if(this.compute2Cond(params)){
            return this.executeEnd(context,params,isloading);   
        }
    }

    /**
    * 服务插件
    * 
    * @param context 应用上下文
    * @param params 传入参数
    */
    private async executeSFPLUGIN1(context:any,params:any,isloading:boolean){
        // SFPLUGIN暂未支持
        console.log("SFPLUGIN暂未支持");
        return this.paramsMap.get(this.defaultParamName).data;
    }

    /**
    * 直接Web调用
    * 
    * @param context 应用上下文
    * @param params 传入参数
    */
    private async executeRAWWEBCALL1(context:any,params:any,isloading:boolean){
        // RAWWEBCALL暂未支持
        console.log("RAWWEBCALL暂未支持");
        return this.paramsMap.get(this.defaultParamName).data;
    }

    /**
    * 实体通知
    * 
    * @param context 应用上下文
    * @param params 传入参数
    */
    private async executeDENOTIFY1(context:any,params:any,isloading:boolean){
        // DENOTIFY暂未支持
        console.log("DENOTIFY暂未支持");
        return this.paramsMap.get(this.defaultParamName).data;
    }

    /**
    * 直接SQL调用
    * 
    * @param context 应用上下文
    * @param params 传入参数
    */
    private async executeRAWSQLCALL1(context:any,params:any,isloading:boolean){
        // RAWSQLCALL暂未支持
        console.log("RAWSQLCALL暂未支持");
        return this.paramsMap.get(this.defaultParamName).data;
    }

    /**
    * 执行脚本代码
    * 
    * @param context 应用上下文
    * @param params 传入参数
    */
    private async executeRAWSFCODE1(context:any,params:any,isloading:boolean){
        // RAWSFCODE暂未支持
        console.log("RAWSFCODE暂未支持");
        return this.paramsMap.get(this.defaultParamName).data;
    }

    /**
    * 结束返回
    * 
    * @param context 应用上下文
    * @param params 传入参数
    */
    private async executeEnd(context:any,params:any,isloading:boolean){
        // END暂未支持
        console.log("END暂未支持");
        return this.paramsMap.get(this.defaultParamName).data;
    }

    /**
    * 实体数据集
    * 
    * @param context 应用上下文
    * @param params 传入参数
    */
    private async executeDEDATASET1(context:any,params:any,isloading:boolean){
        // DEDATASET暂未支持
        console.log("DEDATASET暂未支持");
        return this.paramsMap.get(this.defaultParamName).data;
    }

    /**
    * 获取商品信息
    * 
    * @param context 应用上下文
    * @param params 传入参数
    */
    private async executeDeaction1(context:any,params:any,isloading:boolean){
        // 行为处理节点
        let result: any;
        let actionParam:any = this.paramsMap.get('Product');
        const targetService:IBIZUNIProductService = new IBIZUNIProductService();
        if (targetService['Get'] && targetService['Get'] instanceof Function) {
            result = await targetService['Get'](actionParam.context,actionParam.data, false);
        }
        if(result && result.status == 200){
            Object.assign(actionParam.data,result.data);
        if(this.compute3Cond(params)){
            return this.executePrepareparam2(context,params,isloading);   
        }
        if(this.compute4Cond(params)){
            return this.executeThrowexception(context,params,isloading);   
        }
        }
    }

    /**
    * 系统数据库表操作
    * 
    * @param context 应用上下文
    * @param params 传入参数
    */
    private async executeSYSDBTABLEACTION1(context:any,params:any,isloading:boolean){
        // SYSDBTABLEACTION暂未支持
        console.log("SYSDBTABLEACTION暂未支持");
        return this.paramsMap.get(this.defaultParamName).data;
    }


}